#include <stdio.h>  // Autorise l'emploi de scanf et de printf.

// Fonction de comparaison de deux entiers :


int croissant(int i, int j)
{
    return i > j ;
}
int decroissant(int i, int j)
{
  return i < j ;
}

void changeOrdre(int (**fcomp1)(int, int), int (fcomp2)(int, int))
{
  *fcomp1=fcomp2;
}
// Fonction utilisant une fonction en tant que paramètre :

void trie(int tableau[], int taille, int (fcomp)(int, int))
{
  int i,j,min;
  //tri par permuation avec fcomp comme fonction de comparaison
  for (i=0;i<taille;i++)
    {
      min=tableau[i];
      for (j=i+1;j<taille;j++)
	if (fcomp(tableau[i],tableau[j]))
	  {
	    min = tableau[j];
	    tableau[j]=tableau[i];
	    tableau[i]=min;
	  }
    }
    return ;
}

int main(void)
{
  int i,t[6]={1,5,2,3,6,4};
  int (*fcomp)(int,int);

  fcomp=croissant;
  fprintf(stdout,"Ordre croissant\n ");
  trie(t, 6, fcomp);   // Passage de fonction en paramètre.
  for(i=0;i<6;i++)
    fprintf(stdout," %d ",t[i]);
  fprintf(stdout,"\n");
  
  changeOrdre(&fcomp,decroissant);
  
  fprintf(stdout,"Ordre decroissant\n ");
  trie(t, 6, fcomp);   // Passage de fonction en paramètre.
  for(i=0;i<6;i++)
    fprintf(stdout," %d ",t[i]);
  fprintf(stdout,"\n");
  return 0;
}
